#include "AndFlmsg_Head_CPP.h"
//#include "modem.h"
#include "psk.h"
#include "mt63.h"
#include "thor.h"
#include "mfsk.h"
#include "olivia.h"
//#include "rsid.h"
#include <jni.h>
#include <string.h>



//***************** FROM C++ to JAVA ******************

/*extern bool newAmplReady() {
	//Get access to newAmplReady from Modem class
	jclass myClass = NULL;
	myClass = gEnv->GetObjectClass(gJobject);
//	myClass = gEnv->FindClass("com/AndFlmsg/Modem");
	jfieldID myFid= NULL;
//	myFid = gEnv->GetStaticFieldID(myClass,"newAmplReady","Z");
	myFid = gEnv->GetStaticFieldID(myClass,"newAmplReady","Ljava.lang.boolean");
	bool newAmplReady = gEnv->GetStaticBooleanField(myClass, myFid);
	return newAmplReady;
return true;
}
*/


/*
extern void updateWaterfallBuffer(double *processedFft) {
	jclass myClass = gEnv->GetObjectClass(gJobject);
	jfieldID myFid;
	//	System.arraycopy(aFFTAmpl, 0, Modem.WaterfallAmpl, 0, RSID_FFT_SIZE);
	myFid = gEnv->GetStaticFieldID(myClass,"WaterfallAmpl","[D");
	jdoubleArray WaterFallAmpl = (jdoubleArray)gEnv->GetObjectField(myClass, myFid);
	double *WaterFallAmplPtr = gEnv->GetDoubleArrayElements(WaterFallAmpl, NULL);
	memcpy(WaterFallAmpl, processedFft, 1024 * sizeof(double));
	//	newAmplReady = true;
	myFid = gEnv->GetStaticFieldID(myClass,"newAmplReady","Z");
	gEnv->SetStaticBooleanField(myClass, myFid, false);
}
*/


extern void put_rx_char(int receivedChar) {
	decodedBuffer[lastCharPos++] = receivedChar & 0x7f;
}

//In the mean time, to get the TX section of the modems going
extern int get_tx_char() {
	return 0;
}


extern void change_CModem(int modemCode, double newFrequency) {
	//Delete previously created modem to recover memory used
	if (active_modem) {
		delete active_modem;
		active_modem = NULL;
	}
	//Now re-create with new mode
	if (modemCode > PSK_START && modemCode < PSK_END) {
		active_modem = new psk(modemCode);
	} else if (modemCode > THOR_START && modemCode < THOR_END) {
		active_modem = new thor(modemCode);
	} else if (modemCode > MFSK_START && modemCode < MFSK_END) {
		active_modem = new mfsk(modemCode);
	} else if (modemCode > MT63_START && modemCode < MT63_END) {
		active_modem = new mt63(modemCode);
	} else if (modemCode > OLIVIA_START && modemCode < OLIVIA_END) {
		active_modem = new olivia(modemCode);
	}
	//Do the initializations
	if (active_modem != NULL) {
		//First overall modem initilisation
		active_modem->init();
		//Then init of RX side
		active_modem->rx_init();
		//Then set RX frequency
		active_modem->set_freq(newFrequency);
	}
}

//***************** FROM JAVA to C++  ******************

//Creates the RSID receive Modem
extern "C" JNIEXPORT jstring
Java_com_AndFlmsg_Modem_createRxRsidModem(JNIEnv* env,
		jobject thishere)
{
	RxRsid = new cRsId();
	if (RxRsid != NULL) {
		return (env)->NewStringUTF("RSID Modem created");
	} else {
		return (env)->NewStringUTF("ERROR: RSID Modem Not created");
	}
}


//Returns an array of modem names (uses the RSID list in rsid_def.cxx)
extern "C" JNIEXPORT jobjectArray
Java_com_AndFlmsg_Modem_getModemCapListString(JNIEnv* env,
		jobject thishere)
{
	char *modeCapListString[MAXMODES];
	jobjectArray returnedArray;
	int i;
	int j = 0;

	returnedArray = (jobjectArray)env->NewObjectArray(MAXMODES,
			env->FindClass("java/lang/String"),
			env->NewStringUTF(""));

	for (i=0; i < RxRsid->rsid_ids_size1; i++) {
		if (RxRsid->rsid_ids_1[i].mode != NUM_MODES) {
			env->SetObjectArrayElement(returnedArray,j++,env->NewStringUTF(RxRsid->rsid_ids_1[i].name));
		}
	}

	//do the same for 2nd list
	for (i=0; i < RxRsid->rsid_ids_size2; i++) {
		if (RxRsid->rsid_ids_2[i].mode != NUM_MODES) {
			env->SetObjectArrayElement(returnedArray,j++,env->NewStringUTF(RxRsid->rsid_ids_2[i].name));
		}
	}

	//Finalise the array
	env->SetObjectArrayElement(returnedArray,j,env->NewStringUTF("END"));

	return(returnedArray);

}


//Returns an array of modem codes (uses the RSID list in rsid_def.cxx)
extern "C" JNIEXPORT jintArray
Java_com_AndFlmsg_Modem_getModemCapListInt(JNIEnv* env,
		jobject thishere)
{
	jintArray returnedArray;
	int i;
	int j = 0;

	returnedArray = env->NewIntArray(MAXMODES);
	jint temp[MAXMODES];

	for (i=0; i < RxRsid->rsid_ids_size1; i++) {
		if (RxRsid->rsid_ids_1[i].mode != NUM_MODES) {
			temp[j++] = RxRsid->rsid_ids_1[i].mode;
		}
	}

	//do the same for 2nd list
	for (i=0; i < RxRsid->rsid_ids_size2; i++) {
		if (RxRsid->rsid_ids_2[i].mode != NUM_MODES) {
			temp[j++] = RxRsid->rsid_ids_2[i].mode;
		}
	}

	//Finalise the array with a negtive value
	temp[j] = -1;

	//Copy to Java structure
	env->SetIntArrayRegion(returnedArray, 0, MAXMODES, temp);

	return(returnedArray);

}


//Creates the requested modem in C++
extern "C" JNIEXPORT jstring
Java_com_AndFlmsg_Modem_createCModem( JNIEnv* env,
		jobject thishere, jint modemCode)
{
	//Delete previously created modem to recover memory used
	if (active_modem) {
		delete active_modem;
		active_modem = NULL;
	}
	//Now re-create with new mode
	if (modemCode > PSK_START && modemCode < PSK_END) {
		active_modem = new psk(modemCode);
	} else if (modemCode > THOR_START && modemCode < THOR_END) {
		active_modem = new thor(modemCode);
	} else if (modemCode > MFSK_START && modemCode < MFSK_END) {
		active_modem = new mfsk(modemCode);
	} else if (modemCode > MT63_START && modemCode < MT63_END) {
		active_modem = new mt63(modemCode);
	} else if (modemCode > OLIVIA_START && modemCode < OLIVIA_END) {
		active_modem = new olivia(modemCode);
	} else {
		return (env)->NewStringUTF("ERROR: Modem NOT created");
	}

	return (env)->NewStringUTF("Modem created");
}


//Initializes the RX section of the requested modem in C++
extern "C" JNIEXPORT jstring
Java_com_AndFlmsg_Modem_initCModem( JNIEnv* env,
		jobject thishere, jdouble frequency)
{
	if (active_modem != NULL) {
		//First overall modem initilisation
		active_modem->init();
		//Then init of RX side
		active_modem->rx_init();
		//Then set RX frequency
		active_modem->set_freq(frequency);
		lastCharPos = 0;
		return (env)->NewStringUTF("Modem Initialized");
	} else {
		return (env)->NewStringUTF("ERROR: Modem NOT Initialized");
	}
}



//Processes the audio buffer through the current modem in C++
extern "C" JNIEXPORT jstring
Java_com_AndFlmsg_Modem_rxCProcess( JNIEnv* env,
		jobject thishere, jshortArray myjbuffer, jint length)
{
	//Reset received characters buffer pointer
	lastCharPos = 0;
	//JD check if true (copy) is required here?
	jboolean myjcopy = true;
	//Convert to C++ type
	jshort* shortBuffer = env->GetShortArrayElements(myjbuffer, &myjcopy);

	//Process the buffer in C++
	active_modem->rx_process(shortBuffer, length);
	//Release the passed parameters
	env->ReleaseShortArrayElements(myjbuffer, shortBuffer, 0);

	//JD check this: MUST free the local variable too?
	//example: env->ReleaseFloatArrayElements(*fArray, data, 0);

	//Terminate the buffer
	decodedBuffer[lastCharPos] = 0;

	//Return the decoded data
	return env->NewStringUTF(decodedBuffer);
}


//Updates the modem with the latest GUI squelch level
extern "C" JNIEXPORT jint
Java_com_AndFlmsg_Modem_setSquelchLevel( JNIEnv* env,
		jobject thishere, jdouble squelchLevel)
{
	if ( active_modem != NULL) {
			active_modem->set_squelchLevel(squelchLevel);
		}
	return 0;
}


//Returns the latest signal metric from the current modem in C++
extern "C" JNIEXPORT jdouble
Java_com_AndFlmsg_Modem_getMetric( JNIEnv* env,
		jobject thishere)
{
	double metric = 0.0;
	if ( active_modem != NULL) {
		metric = active_modem->get_metric();
	}
	return metric;
}

//Processes the audio buffer through the RSID modem
extern "C" JNIEXPORT jstring
Java_com_AndFlmsg_Modem_RsidCModemReceive( JNIEnv* env,
		jobject thishere, jfloatArray myfbuffer, jint length)
{
	//Save environment for later usage
	//	gEnv = env;
	//	gJobject = thishere;

	//Convert to C++ type
	jboolean myjcopy = true;
	jfloat* floatBuffer = env->GetFloatArrayElements(myfbuffer, &myjcopy);
	//Reset received characters buffer pointer
	lastCharPos = 0;
	//Process the buffer in C++
	RxRsid->receive(env, thishere, floatBuffer, length);
	//Release the passed parameters
	env->ReleaseFloatArrayElements(myfbuffer, floatBuffer, 0);
	//Terminate the buffer
	//debug	decodedBuffer[lastCharPos++] = 'z';
	decodedBuffer[lastCharPos] = 0;

	return env->NewStringUTF(decodedBuffer);

}

//Returns the current modem frequency (for waterfall tracking after RSID)
extern "C" JNIEXPORT jdouble
Java_com_AndFlmsg_Modem_getCurrentFrequency( JNIEnv* env,
		jobject thishere)
{
	return active_modem->get_freq();
}

//Returns the current modem frequency (for waterfall tracking after RSID)
extern "C" JNIEXPORT jint
Java_com_AndFlmsg_Modem_getCurrentMode( JNIEnv* env,
		jobject thishere)
{
	return active_modem->get_mode();
}


