/*
 * AndFlmsg.java  
 *   
 * Copyright (C) 2014 John Douyere (VK2ETA)  
 *   
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
 * GNU General Public License for more details.  
 *   
 * You should have received a copy of the GNU General Public License  
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.  
 */

package com.AndFlmsg; 

/**
 *
 * @author John Douyere <vk2eta@gmail.com>
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URLDecoder;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.database.Cursor;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.location.GpsStatus;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.AudioManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.provider.ContactsContract.CommonDataKinds.Email;
import android.provider.ContactsContract.Contacts;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.text.format.Time;
import android.view.Display;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.LayoutAnimationController;
import android.view.animation.TranslateAnimation;
import android.view.inputmethod.InputMethodManager;
import android.webkit.WebView;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.ProgressBar;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;




public class AndFlmsg extends Activity {

	public static Context myContext;

	public static Window myWindow = null;

	public static boolean RXParamsChanged = false;

	public static SharedPreferences mysp = null;

	// Last screen used (Mesages, Terminal, Modem, etc...)
	private int lastMsgScreen = MSGTEXTVIEW; //default to start with
	//	private static ArrayList<email> emaillist;
	private static LayoutInflater inflater = null;
	private PopupWindow pw;
	private static String welcomeString = "\n Welcome to AndFlmsg " + Processor.version + "\n\n This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.\n\n Swipe across the screen to navigate to the other screens and use the device Menu button to get access to the preferences and additional functions.\n\n Visit www.w1hkj.com for more details\n\n 73, The Fldigi Team \n\n";
	private static boolean hasDisplayedWelcome = false;

	//Horizontal Fling detection despite scrollview
	private GestureDetector mGesture;

	// Views values
	private final static int TERMVIEW = 1;
	private final static int MODEMVIEWnoWF = 3;
	private final static int MODEMVIEWwithWF = 4;
	private final static int ABOUTVIEW = 6;
	private final static int MSGTEXTVIEW = 7;
	private final static int MSGHTMLVIEW = 8;
	private final static int MSGTEMPLATEVIEW = 9;
	private final static int MSGSENTITEMSVIEW = 10;
	private final static int NEWMSGVIEW = 11;

	//screen transitions / animations
	private static final int NORMAL = 0;
	private static final int LEFT = 1;
	private static final int RIGHT = 2;
	private static final int TOP = 3;
	private static final int BOTTOM = 4;


	static ProgressBar SignalQuality = null;
	static ProgressBar CpuLoad = null;

	static int currentview = 0;

	//Toast text display (declared here to allow for quick replacement rather than queuing)
	private Toast myToast;

	//Forms display and forward
	private static String mDisplayForm = new String();
	private static String mFileName = new String();

	// Layout Views
	private static TextView myTermTV;
	private static ScrollView myTermSC;
	private static TextView myModemTV;
	private static ScrollView myModemSC;
	private static waterfallView myWFView;

	private ListView msgListView;
	private WebView mWebView;
	// Generic button variable. Just for callback initialisation
	private Button myButton;

	public static LocationManager locationManager;
	public GPSListener locationListener = new GPSListener();
	public static boolean GPSisON = false;
	public static boolean GPSTimeAcquired = false;
	public static int DeviceToGPSTimeCorrection = 0;

	public static String TerminalBuffer = "";
	public static String ModemBuffer = "";

	// Member object for processing of Rx and Tx
	// Can be stopped (i.e no RX) to save battery and allow Android to reclaim
	// resources if not visible to the user
	public static boolean ProcessorON = false;
	private static boolean modemPaused = false;

	//Notifications
	private NotificationManager myNotificationManager;
	private Notification myNotification;	

	// Array adapter for the messages' list
	public static ArrayAdapter<String> msgArrayAdapter;

	// Need handler for callbacks to the UI thread
	public static final Handler mHandler = new Handler();

	//Contact email picker
	private static final int CONTACT_PICKER_RESULT = 10101;

	// Bluetooth handfree / headset
	public static boolean scoChannelOn = false;
	public static boolean toBluetooth = false;
	public static AudioManager mAudioManager;
	public static BluetoothAdapter mBluetoothAdapter = null;
	//To monitor the incoming calls and disconnect Bluetooth so that we don't send the phone call audio to the radio
	private TelephonyManager tmgr = null;
	/* Parked code for later
	//  Broadcast receiver for Bluetooth  broadcasts 
	//	private final BroadcastReceiver myBroadcastReceiver = new mBroadcastReceiver();

	// Need to start an audio channel with the Bluetooth headset/handsfree
	// Either use startVoiceRecognition() (V3.0 onwards)
	// OR
	// StartBluetoothSCO() (V2.2 Onwards)
	 * BluetoothHeadset mBluetoothHeadset;
	 * 
	 * private BluetoothHeadset.ServiceListener mBluetoothHeadsetServiceListener
	 * = new BluetoothHeadset.ServiceListener() { public void
	 * onServiceConnected() { if (mBluetoothHeadset != null &&
	 * mBluetoothHeadset.getState() == BluetoothHeadset.STATE_CONNECTED) { //
	 * Log.e(TAG, "######### STARTING VOICE RECOGNITION ############");
	 * mBluetoothHeadset.startVoiceRecognition();
	 * mAudioManager.setMode(AudioManager.MODE_IN_CALL); } } public void
	 * onServiceDisconnected() { int aaa = 0; }
	 * 
	 * };
	 */


	// Listener for changes in preferences
	public static OnSharedPreferenceChangeListener splistener;


	// Create runnable for updating the waterfall display
	public static final Runnable updatewaterfall = new Runnable() {
		public void run() {
			if (myWFView != null) {
				//myWFView.invalidate();
				myWFView.postInvalidate();
			}
		}
	};

	// Create runnable for changing the main window's title
	public static final Runnable updatetitle = new Runnable() {
		public void run() {
			if (myWindow != null) {
				if (ProcessorON) {
					if (Processor.TXActive) {
						myWindow.setTitleColor(Color.YELLOW);
					} else {
						myWindow.setTitleColor(Color.CYAN);
					}
				} else {
					myWindow.setTitleColor(Color.WHITE);
				}
				int mIndex = Modem.getModeIndex(Processor.RxModem);
				myWindow.setTitle("AndFlmsg-" + Processor.Status + " - "
						+ Modem.customModeListString[mIndex]);
			}
		}
	};

	// Runnable for updating the signal quality bar in Modem Window
	public static final Runnable updatesignalquality = new Runnable() {
		public void run() {
			if ((SignalQuality != null)
					&& ((currentview == MODEMVIEWnoWF) || (currentview == MODEMVIEWwithWF))) {
				SignalQuality.setProgress((int) Modem.metric);
				SignalQuality.setSecondaryProgress((int) Modem.squelch);
			}
		}
	};

	// Runnable for updating the CPU load bar in Modem Window
	public static final Runnable updatecpuload = new Runnable() {
		public void run() {
			if ((CpuLoad != null)
					&& ((currentview == MODEMVIEWnoWF) || (currentview == MODEMVIEWwithWF))) {
				CpuLoad.setProgress((int) Processor.cpuload);
			}
		}
	};


	// Create runnable for posting to terminal window
	public static final Runnable addtoterminal = new Runnable() {
		public void run() {
			// myTV.setText(Processor.TermWindow);
			if (myTermTV != null) {
				myTermTV.append(Processor.TermWindow);
				TerminalBuffer += Processor.TermWindow;
				if (TerminalBuffer.length() > 60000)
					TerminalBuffer = TerminalBuffer.substring(5000);
				Processor.TermWindow = "";
				// Then scroll to the bottom
				if (myTermSC != null) {
					myTermSC.post(new Runnable() {
						public void run() {
							myTermSC.fullScroll(View.FOCUS_DOWN);
						}
					});
				}
			}
		}
	};

	// Create runnable for posting to modem window
	public static final Runnable addtomodem = new Runnable() {
		public void run() {
			// myTV.setText(Processor.TermWindow);
			if (myModemTV != null) {
				myModemTV.append(Processor.monitor);
				ModemBuffer += Processor.monitor;
				if (ModemBuffer.length() > 60000)
					ModemBuffer = ModemBuffer.substring(5000);
				Processor.monitor = "";
				// Then scroll to the bottom
				if (myModemSC != null) {
					myModemSC.post(new Runnable() {
						public void run() {
							myModemSC.fullScroll(View.FOCUS_DOWN);
							//myModemSC.smoothScrollBy(20,0);
						}
					});
				}
			}
		}
	};




	//Phone state listener to disable Bluetooth when receiving a call
	//This is to prevent the phone call's audio to be sent to the radio,
	// as well as stopping the TXing from this app until the phone call is finished
	//This action is only active when we have enabled Bluetooth in the application
	private PhoneStateListener mPhoneStateListener = new PhoneStateListener() {
		@Override
		public void onCallStateChanged(int state, String incomingNumber) {
			if (state == TelephonyManager.CALL_STATE_RINGING) {
				//Log.v(TAG, " CALL_STATE_RINGING");
				//If using the bluetooth interface for the digital link, 
				//  disable it otherwise the phone call will use it.
				if (AndFlmsg.toBluetooth) {
					AndFlmsg.toBluetooth = false;
					AndFlmsg.mAudioManager.setMode(AudioManager.MODE_NORMAL);
					if (Double.valueOf(android.os.Build.VERSION.SDK) > 8) { //Froyo bug
						AndFlmsg.mAudioManager.stopBluetoothSco();
						if (AndFlmsg.mBluetoothAdapter != null) {
							if (AndFlmsg.mBluetoothAdapter.isEnabled()) {
								AndFlmsg.mBluetoothAdapter.disable(); 
							} 
						}
					}
					AndFlmsg.mAudioManager.setBluetoothScoOn(false);
				}

			} else if (state == TelephonyManager.CALL_STATE_IDLE) {
				//Log.v(TAG, " CALL_STATE_IDLE");
			}
		}
	};


	public void DisplayTime() {
		runOnUiThread(new Runnable() {
			public void run() {
				if (currentview == TERMVIEW) {
					try{
						TextView txtCurrentTime= (TextView)findViewById(R.id.minsec);
						long nowInMilli = System.currentTimeMillis();
						Time mytime = new Time();
						//Not using GPS time? Make sure the variables are reset
						if (!config.getPreferenceB("USEGPSTIME", false)) {
							DeviceToGPSTimeCorrection = 0;
							GPSTimeAcquired = false;
						}
						mytime.set(nowInMilli + (DeviceToGPSTimeCorrection * 1000) ); //now +/- GPS correction if any
						String MinutesStr = "00" + mytime.minute  ;
						MinutesStr = MinutesStr.substring(MinutesStr.length() - 2, MinutesStr.length());
						String SecondsStr = "00" + mytime.second  ;
						SecondsStr = SecondsStr.substring(SecondsStr.length() - 2, SecondsStr.length());
						txtCurrentTime.setText(MinutesStr + ":" + SecondsStr);
						if (GPSTimeAcquired) {
							txtCurrentTime.setTextColor(Color.GREEN);
						} else {
							txtCurrentTime.setTextColor(Color.YELLOW);
						}
					}catch (Exception e) {}
				}
			}
		});
	}


	class DisplayTimeRunner implements Runnable{
		// @Override
		public void run() {
			while(!Thread.currentThread().isInterrupted()){
				try {
					DisplayTime();
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					Thread.currentThread().interrupt();
				}catch(Exception e){
				}
			}
		}
	}


	@Override
	public boolean dispatchTouchEvent(MotionEvent ev) {
		boolean handled = super.dispatchTouchEvent(ev);
		handled = mGesture.onTouchEvent(ev);    
		return handled;
	}


	private SimpleOnGestureListener mOnGesture = new GestureDetector.SimpleOnGestureListener() {
		private float xDistance, yDistance, lastX, lastY;

		@Override
		public boolean onDown(MotionEvent e) {
			xDistance = yDistance = 0f;
			lastX = e.getX();
			lastY = e.getY();
			return false;
		}

		@Override
		public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
			final float curX = e2.getX();
			final float curY = e2.getY();
			xDistance += (curX - lastX);
			yDistance += (curY - lastY);
			lastX = curX;
			lastY = curY;
			if(Math.abs(xDistance) > Math.abs(yDistance) && Math.abs(velocityX) > 1000) {
				//toastText("fling......");
				NavigateScreens((int) xDistance);
				return false;
			}
			return true;
		}

		@Override
		public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
			return false;
		}
	};    


	//Swipe (fling) handling to move from screen to screen
	private void NavigateScreens(int FlingDirection){

		//Navigate between screens by gesture (on top of menu button acces)

		if (FlingDirection > 0) { //swipe/fling right

			switch (currentview) {

			case TERMVIEW : displayMessages(RIGHT, lastMsgScreen);
				break; 

			case  MODEMVIEWnoWF :
			case  MODEMVIEWwithWF : displayTerminal(RIGHT);
			break; 

			case MSGTEXTVIEW : 
			case MSGHTMLVIEW :
			case MSGTEMPLATEVIEW :
			case MSGSENTITEMSVIEW :
				//displayInforequest(RIGHT);
				displayModem(RIGHT, false);
				break; 

			case NEWMSGVIEW :
				//do nothing
				break;

			default: displayTerminal(RIGHT); //Just in case


			}
		} else { //swipe/fling left
			switch (currentview) {

			case TERMVIEW : displayModem(LEFT, false);
			break; 

			case  MODEMVIEWnoWF : 
			case  MODEMVIEWwithWF : 
				// displayAPRS(LEFT);
				displayMessages(LEFT, lastMsgScreen);
				break; 

			case MSGTEXTVIEW : 
			case MSGHTMLVIEW :
			case MSGTEMPLATEVIEW :
			case MSGSENTITEMSVIEW :
				displayTerminal(LEFT);
				break; 

			case NEWMSGVIEW :
				//do nothing
				break;

			default: displayTerminal(LEFT); //Just in case

			} 

		}

	}



	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// Call the folder handling method
		Processor.handlefolderstructure();

		//Get new gesture detector for flings over scrollviews
		mGesture = new GestureDetector(this, mOnGesture);

		//Initialize Toast for use in the Toast display routines below
		myToast = Toast.makeText(AndFlmsg.this, "",	Toast.LENGTH_SHORT);

		//Debug
		//topToastText("ONCREATE CALLED");
		//middleToastText("ONCREATE CALLED");

		//Get a static copy of the base myContext
		myContext = this.getBaseContext();

		//Initialize the notification manager
		myNotificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);

		// Bluetooth
		mAudioManager = (AudioManager) myContext
				.getSystemService(Context.AUDIO_SERVICE);
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();    

		// Register for phone state monitoring
		tmgr = (TelephonyManager)
				myContext.getSystemService(Context.TELEPHONY_SERVICE);
		tmgr.listen(mPhoneStateListener, PhoneStateListener.LISTEN_CALL_STATE);

		//Launch task for time display (Time is GPS time aligned if requested)
		Thread myThread = null;

		Runnable runnable = new DisplayTimeRunner();
		myThread= new Thread(runnable);
		myThread.start();

		//init NMEA listener for GPS time (to negate the device clock drift when not in mobile reception area)
		locationManager = (LocationManager) this
				.getSystemService(Context.LOCATION_SERVICE);
		locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
		locationManager.addNmeaListener(new GpsStatus.NmeaListener() {
			public void onNmeaReceived(long timestamp, String nmea) {
				if (config.getPreferenceB("USEGPSTIME", false)) {
					String[] NmeaArray = nmea.split(",");
					if (NmeaArray[0].equals("$GPGGA")){
						//debug
						//Processor.Terminalwindow += "\n NMEA is :"+nmea;
						//AndFlmsg.mHandler.post(AndFlmsg.addtoTerminal);
						if (NmeaArray[1].indexOf(".") > 4) {
							String GpsTime = NmeaArray[1].substring(0,NmeaArray[1].indexOf("."));
							GPSTimeAcquired = true; //Mark that we have acquired time (for the clock colour display and autobeacon time)
							GpsTime = "000000" + GpsTime;
							//							Processor.APRSwindow += " GpsTime:" + GpsTime + "\n";
							GpsTime = GpsTime.substring(GpsTime.length() - 4, GpsTime.length());
							int GpsMin = Integer.parseInt(GpsTime.substring(0,2));
							int GpsSec = Integer.parseInt(GpsTime.substring(2,4));
							//Apply leap seconds correction: GPS is 16 seconds faster than UTC as of June 2013.
							//Some devices do not apply this automatically (depends on the internal GPS engine)
							int leapseconds = Integer.parseInt(config.getPreference("LEAPSECONDS", "0"));
							GpsSec -= leapseconds;
							if (GpsSec < 0) {
								GpsSec += 60;
								GpsMin --;
								if (GpsMin < 0) {
									GpsMin += 60;
								}
							}
							//In case of (unexpected) negative leap seconds values
							if (GpsSec > 60) {
								GpsSec -= 60;
								GpsMin ++;
								if (GpsMin > 60) {
									GpsMin -= 60;
								}
							}
							//Compare to current device time and date and calculate the offset to be applied at display
							long nowInMilli = System.currentTimeMillis();
							long timeTarget = nowInMilli;
							Time mytime = new Time();
							mytime.set(timeTarget); //initialized to now
							int DeviceTime = mytime.second + (mytime.minute * 60);
							DeviceToGPSTimeCorrection = (GpsSec + (GpsMin * 60)) - DeviceTime;
						}
					}
					//loggingclass.writelog("Timestamp is :" +timestamp+"   nmea is :"+nmea,
					//					  null, true);
				}
			}});


		// Init config
		mysp = PreferenceManager.getDefaultSharedPreferences(this);
		String mypath = Processor.HomePath + Processor.Dirprefix;

		// Set default modes
//JD Debug TODO: start with last mode used
//		Processor.TxModem  = Processor.RxModem = 101;
//		Processor.TxModem = Modem.getMode((config.getPreference("DEFAULTMODE","PSK31")));
//		Processor.RxModem = Modem.getMode((config.getPreference("DEFAULTMODE","PSK31")));

		// We start with the terminal "screen"
		displayTerminal(NORMAL);
	}

	/** Called when the activity is (re)started (to foreground) **/
	@Override
	public void onStart() {
		super.onStart();
		// Store preference reference for later (config.java)
		mysp = PreferenceManager.getDefaultSharedPreferences(this);
		String mypath = Processor.HomePath + Processor.Dirprefix;
		//		myconfig = new config(mypath);
		// Refresh defaults since we could be coming back
		// from the preference activity

		// Re-initilize modem when NOT busy to use the latest parameters
		if (!Processor.ReceivingForm   && RXParamsChanged) {
			// Reset flag then stop and restart modem
			RXParamsChanged = false;
			//Cycle modem service off then on
			if (ProcessorON) {
				if (Modem.modemState == Modem.RXMODEMRUNNING) {
					Modem.stopRxModem();	
					stopService(new Intent(AndFlmsg.this, Processor.class));
					ProcessorON = false;
					//Force garbage collection to prevent Out Of Memory errors on small RAM devices
					System.gc();
				}
			}
			//Wait for modem to stop and then restart
			while (Modem.modemState != Modem.RXMODEMIDLE) {
				try {
					Thread.sleep(250);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			//Force garbage collection to prevent Out Of Memory errors on small RAM devices
			System.gc();
			//Get current mode index (returns first position if not in list anymore in case we changed to custom mode list on the current mode)
			Processor.RxModem = Processor.TxModem = Modem.customModeListInt[Modem.getModeIndex(Processor.RxModem)];
			startService(new Intent(AndFlmsg.this,
					Processor.class));
			ProcessorON = true;

			//Finally, if we were on the modem screen AND we come back to it, then
			//   redisplay in case we changed the waterfall frequency
			if (currentview == MODEMVIEWwithWF) {
				displayModem(NORMAL, true);
			}
		} else { // start if not ON yet AND we haven't paused the modem manually
			if (!ProcessorON && !modemPaused) {
				//Force garbage collection to prevent Out Of Memory errors on small RAM devices
				System.gc();
				startService(new Intent(AndFlmsg.this, Processor.class));
				ProcessorON = true; 
				//Only for Android 3.0 and UP
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
					Intent notificationIntent = new Intent(this, AndFlmsg.class);
					notificationIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
					PendingIntent pIntent = PendingIntent.getActivity(this, 0, notificationIntent, 0);

					// build notification
					// the addAction re-use the same intent to keep the example short
					myNotification = new Notification(R.drawable.notificationicon, 
							"Modem ON", System.currentTimeMillis());

					myNotification.setLatestEventInfo(myContext, "Fdigi Modem ON", 
							"Microphone/Bluetooth in use by Modem", pIntent);

					myNotification.flags |= Notification.FLAG_NO_CLEAR;

					myNotificationManager.notify(9999, myNotification); 
				}
			}
		}
		AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
	}

	@Override
	public void onPause() {
		super.onPause();
		//Save the values of key fields when we quit the current application (calling another application or pressing the back button)
		/* Not needed with the textwatch method
 		if (currentview == XYZVIEW) {
			TextView view = (TextView) findViewById(R.id.edit_text_out);
			if (view != null) {
				savedAprsMessage = view.getText().toString();
			}
		}
		 */
	}

	@Override
	public void onResume() {
		super.onResume();
		//Save the values of key fields when we quit the current application (calling another application or pressing the back button)
		/*		if (currentview == XYZVIEW) {
			TextView view = (TextView) findViewById(R.id.edit_text_out);
			if (view != null) {
				view.setText(savedAprsMessage);
			}
		}
		 */
	}


	@Override
	public void onDestroy() {
		super.onDestroy();
	}


	// Option Menu
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}


	/* Parked code for monitoring the user-controlled enabling of the Bluetooth interface
	@Override
   public void onActivityResult(int requestCode, int resultCode, Intent data) {
        switch (requestCode) {
        case REQUEST_CONNECT_DEVICE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                // Get the device MAC address
                String address = data.getExtras()
                                     .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                // Get the BLuetoothDevice object
                BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
                // Attempt to connect to the device
                mChatService.connect(device);
            }
            break;

        case REQUEST_ENABLE_BT:
            // When the request to enable Bluetooth returns
            if (resultCode == Activity.RESULT_OK) {
                // Bluetooth is now enabled, so set up an audio channel
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8) {
					mAudioManager.startBluetoothSco();
				} 
				//Android 2.1. Needs testinband.apk to be launched before hand 
				mAudioManager.setMode(AudioManager.MODE_IN_CALL);
				mAudioManager.setBluetoothScoOn(true);
				// mAudioManager.setSpeakerphoneOn(false);
				toBluetooth = true;
            } else {
                // User did not enable Bluetooth or an error occured
				toBluetooth = false;
				Toast.makeText(this, "Bluetooth has not been enabled", Toast.LENGTH_LONG).show();
            }
        }
    }
	 */



	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (resultCode == RESULT_OK && data != null) {
			switch (requestCode) {
			case CONTACT_PICKER_RESULT:
				Cursor cursor = null;
				String email = "";
				try {
					Uri result = data.getData();
					// get the contact id from the Uri
					String id = result.getLastPathSegment();

					// query for everything email
					cursor = getContentResolver().query(Email.CONTENT_URI,
							null, Email.CONTACT_ID + "=?", new String[] { id },
							null);

					int emailIdx = cursor.getColumnIndex(Email.DATA);

					// let's just get the first email
					if (cursor.moveToFirst()) {
						email = cursor.getString(emailIdx);
					}
				} catch (Exception ex) {
					loggingclass.writelog("Failed to get email data" + ex.getMessage(),
							null, true);
				} finally {
					if (cursor != null) {
						cursor.close();
					}
					EditText emailEntry = (EditText) findViewById(R.id.emailaddress);
					if (emailEntry != null) emailEntry.setText(email);
					if (email.length() == 0) {
						Toast.makeText(this, "No email found for contact.",
								Toast.LENGTH_SHORT).show();
					}

				}

				break;
			}

		} else {
			//not for now:  Log.w(DEBUG_TAG, "Warning: activity result not ok");
		}
	}


	// Option Screen handler
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
		switch (item.getItemId()) {
		case R.id.prefs:
			Intent OptionsActivity = new Intent(getBaseContext(), myPreferences.class);
			startActivity(OptionsActivity);
			break;
		case R.id.About:
			displayAbout();
			break;
		case R.id.BTon:
			// mBluetoothHeadset.startVoiceRecognition();
			if (mBluetoothAdapter != null) {
				//Code that works (Manual connect to BT device)
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8) {
					mAudioManager.startBluetoothSco();
				}
				mAudioManager.setMode(AudioManager.MODE_IN_CALL);
				mAudioManager.setBluetoothScoOn(true);
				toBluetooth = true;
			}
			break;
		case R.id.BToff:
			// old code that worked!!!!
			toBluetooth = false;
			mAudioManager.setMode(AudioManager.MODE_NORMAL);
			mAudioManager.setBluetoothScoOn(false);
			if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8) {
				mAudioManager.stopBluetoothSco();
			}
			break;
		case R.id.exit:
			myAlertDialog.setMessage("Are you sure you want to Exit?");
			myAlertDialog.setCancelable(false);
			myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					//					Toast.makeText(this, "GoodBye", Toast.LENGTH_SHORT).show();
					// Stop the Modem and Listening Service
					if (ProcessorON) {
						stopService(new Intent(AndFlmsg.this, Processor.class));
						ProcessorON = false;
						//Only for Android 3.0 and UP
						if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//Remove the notification
							myNotificationManager.cancel(9999);
							ProcessorON = false;
						}
					}
					// Stop the GPS if running
					if (locationManager != null) {
						locationManager.removeUpdates(locationListener);
					}
					//Close that activity and return to previous screen
					finish();
					//Kill the process
					android.os.Process.killProcess(android.os.Process.myPid());
				}	
			});
			myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					dialog.cancel();
				}
			});	
			myAlertDialog.show();
			break;
		case R.id.clearReceived:
			myAlertDialog.setMessage("Are you sure you want to Clear ALL the Received Messages?");
			myAlertDialog.setCancelable(false);
			myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					//					Processor.sm.deleteFile("received");
					middleToastText("Deleted ALL Received Messages...");
				}
			});
			myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					dialog.cancel();
				}
			});	
			myAlertDialog.show();
			break;
		case R.id.clearpending:
			myAlertDialog.setMessage("Are you sure you want to Clear the OUTBOX?");
			myAlertDialog.setCancelable(false);
			myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					ClearOutbox();
					middleToastText("Cleared Outbox...");
				}
			});
			myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					dialog.cancel();
				}
			});	
			myAlertDialog.show();
			break;
		}
		return true;
	}

	// Handles callbacks from GPS service
	private class GPSListener implements LocationListener {

		public void onLocationChanged(Location location) {
		}

		public void onStatusChanged(String s, int i, Bundle b) {
		}

		public void onProviderDisabled(String s) {
			//toastText("GPS turned off - Please turn ON");
			GPSisON = false;
		}

		public void onProviderEnabled(String s) {
			//toastText("GPS turned ON");
			GPSisON = true;
		}
	}


	// Simple text transparent popups (bottom of screen)
	private void topToastText(String message) {
		try {
			myToast.setText(message);
			myToast.setGravity(Gravity.TOP, 0	, 100);
			myToast.show();
		} catch (Exception ex) {
			loggingclass.writelog("Toast Message error: " + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}
	}



	// Simple text transparent popups TOWARDS MIDDLE OF SCREEN
	private void middleToastText(String message) {
		try {
			myToast.setText(message);
			myToast.setGravity(Gravity.CENTER, 0	, 0);
			myToast.show();
		} catch (Exception ex) {
			loggingclass.writelog("Toast Message error: " + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}
	}


	// Simple text transparent popups
	private void bottomToastText(String message) {
		try {
			myToast.setText(message);
			myToast.setGravity(Gravity.BOTTOM, 0, 100);
			myToast.show();
		} catch (Exception ex) {
			loggingclass.writelog("Toast Message error: " + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}
	}



	//For storing Boolean preferences
	public void storePreferenceB(String pref, boolean flag) {
		//store value into preferences
		SharedPreferences.Editor editor = AndFlmsg.mysp.edit();
		editor.putBoolean(pref, flag);
		// Commit the edits!
		editor.commit();
	}


	public static void screenAnimation(ViewGroup panel, int screenAnimation) {

		AnimationSet set = new AnimationSet(true);

		Animation animation = new AlphaAnimation(0.0f, 1.0f);
		animation.setDuration(100);
		set.addAnimation(animation);

		switch(screenAnimation) {

		case NORMAL:
			return;
			//break;

		case RIGHT:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, -1.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;
		case LEFT:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, 1.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;

		case TOP:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, -1.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;

		case BOTTOM:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, 1.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;

		}

		animation.setDuration(200);
		set.addAnimation(animation);

		LayoutAnimationController controller = new LayoutAnimationController(set, 0.25f);
		if (panel != null) {
			panel.setLayoutAnimation(controller);
		}
	}

	/*
	private void connectDialog() {
		AlertDialog.Builder myAlertBuilder = new AlertDialog.Builder(this);
		LayoutInflater myInflater = LayoutInflater.from(this);
		final View connectDialogView = myInflater.inflate(R.layout.connectdialog, null);
		myAlertBuilder.setView(connectDialogView)
				.setCancelable(true).setNegativeButton(
				"Cancel", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// Hide the keyboard since we handle it manually
						InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
						imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
						dialog.cancel();
					}
				})
				.setPositiveButton("Connect", new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int id) {
						// Stop the GPS if running (saves batteries and is of no use
						// while in a session
						if (locationManager != null) {
							locationManager.removeUpdates(locationListener);
						}
						TextView view = (TextView) connectDialogView.findViewById(R.id.edit_text_connect);
						serverToCall = view.getText().toString().trim();
						if (serverToCall.length() == 0) {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
							dialog.cancel();
							middleToastText("Server Call can't be blank");
						} else {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
							//Send the connect command
							Processor.Connecting = true;
							Processor.Status = "Connecting";
							//Reset receiving modem to default centre frequency
//							Processor.m.reset();
//							Processor.q.send_rsid_command("ON");
//							Processor.q.set_txstatus(txstatus.TXConnect);
//							Processor.q.send_frame("");
						}
					}
				});

		AlertDialog myConnectAlert = myAlertBuilder.create();
		EditText view = (EditText) connectDialogView.findViewById(R.id.edit_text_connect);
		if (serverToCall.length() == 0) { //use default server call from preferences
			String defaultServerCall = config.getPreference("SERVER");
			view.setText(defaultServerCall);
		} else { //We had already typed-in a server call. Propose first as we are likely to use it again
			view.setText(serverToCall);
		}
		myConnectAlert.setTitle("Connection Server");
		myConnectAlert.show();

	}

	 */


	// Display the Terminal layout and associate it's buttons
	private void displayTerminal(int screenMovement) {
		//If we elected to use GPS time, start GPS listening now
		if (config.getPreferenceB("USEGPSTIME", false)) {
			locationManager = (LocationManager) this
					.getSystemService(Context.LOCATION_SERVICE);
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
					60000, // milisecs
					0, // meters
					locationListener);
		}
		// Change layout and remember which one we are on
		currentview = TERMVIEW;
		setContentView(R.layout.terminal);
		screenAnimation((ViewGroup) findViewById(R.id.termscreen), screenMovement);
		myTermTV = (TextView) findViewById(R.id.terminalview);
		myTermTV.setHorizontallyScrolling(false);
		myTermTV.setTextSize(16);
		myWindow = getWindow();
		AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
		// If blank (on start), display version
		if (TerminalBuffer.length() == 0 && !hasDisplayedWelcome) {
			TerminalBuffer = welcomeString;
		} else {
			if (TerminalBuffer.equals(welcomeString)) {
				TerminalBuffer = "";
			}
		}
		hasDisplayedWelcome = true;
		// Reset terminal display in case it was blanked out by a new oncreate call
		myTermTV.setText(TerminalBuffer);
		myTermSC = (ScrollView) findViewById(R.id.terminalscrollview);
		// update with whatever we have already accumulated then scroll
		AndFlmsg.mHandler.post(AndFlmsg.addtoterminal);
		//Advise which screen we are in
		topToastText("Terminal Screen");

		// JD Initialize the Send Text button (commands in connected mode)
		myButton = (Button) findViewById(R.id.button_sendtext);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget
				TextView view = (TextView) findViewById(R.id.edit_text_out);
				String intext = view.getText().toString();

				try {
					if (!Processor.ReceivingForm) {
						Processor.TX_Text += (intext + "\n");
						//						Processor.q.send_txrsid_command("ON");
						//						Processor.m.sendln(intext + "\n");
					} else {
						bottomToastText("Not while in the middle of receiving a message");
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					System.out.println(ex.getMessage());
				}
			}
		});

		// JD Initialize the Connect button
		myButton = (Button) findViewById(R.id.button_connect);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {

				if (!Processor.ReceivingForm) {
					File f = new File(Processor.HomePath + Processor.Dirprefix + "Received" + Processor.Separator + "sample.txt");
					try
					{
						FileInputStream fileIS = new FileInputStream(f);
						BufferedReader buf = new BufferedReader(new InputStreamReader(fileIS));
						int readInt;
						try
						{
							while ((readInt = buf.read()) != -1)
							{
								Modem.processRxChar((char) (readInt & 0x7F));
							}
						}
						catch (IOException e)
						{}
					}
					catch (FileNotFoundException e)
					{}
				}
			}
		});


		/*

		// JD Initialize the SEND Mail button
		myButton = (Button) findViewById(R.id.button_sendmail);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					SendButtonAction();
				}
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the ABORT button
		myButton = (Button) findViewById(R.id.button_abort);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					AbortButtonAction();
				}
				catch (Exception ex) {
					// System.out.println(ex.getMessage());
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the STOP button
		myButton = (Button) findViewById(R.id.button_stop);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (Processor.ReceivingForm) {

					try {
						Processor.TX_Text += "~STOP:"
								+ Processor.sm.Transaction + "\n";
						topToastText("Sending STOP command...");
					}
					catch (Exception ex) {
						// System.out.println(ex.getMessage());
						loggingclass.writelog(
								"Button Execution error: " + ex.getMessage(),
								null, true);
					}
				} else {
					topToastText("Only while Connected");
				}
			}
		});

		 */

	}

	/*
	private void linkDialog() {
		AlertDialog.Builder myAlertBuilder = new AlertDialog.Builder(this);
		LayoutInflater myInflater = LayoutInflater.from(this);
		final View connectDialogView = myInflater.inflate(R.layout.connectdialog, null);
		myAlertBuilder.setView(connectDialogView)
				.setCancelable(true).setNegativeButton(
				"Cancel", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// Hide the keyboard since we handle it manually
						InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
						imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
						dialog.cancel();
					}
				})
				.setPositiveButton("Link", new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int id) {
						TextView view = (TextView) connectDialogView.findViewById(R.id.edit_text_connect);
						serverToCall = view.getText().toString().trim();
						if (serverToCall.length() == 0) {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
							dialog.cancel();
							middleToastText("Server Call can't be blank");
						} else {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
							//Send the Inquire command
							try {
//								Processor.q.send_link();
							}
							catch (Exception ex) {
								loggingclass.writelog(
										"Button Execution error: " + ex.getMessage(), null,
										true);
							}
						}
					}
				});

		AlertDialog myConnectAlert = myAlertBuilder.create();
		EditText view = (EditText) connectDialogView.findViewById(R.id.edit_text_connect);
		if (serverToCall.length() == 0) { //use default server call from preferences
			String defaultServerCall = config.getPreference("SERVER");
			view.setText(defaultServerCall);
		} else { //We had already typed-in a server call. Propose first as we are likely to use it again
			view.setText(serverToCall);
		}
		myConnectAlert.setTitle("Server to Link to");
		myConnectAlert.show();
	}


	private void inquireDialog() {
		AlertDialog.Builder myAlertBuilder = new AlertDialog.Builder(this);
		LayoutInflater myInflater = LayoutInflater.from(this);
		final View connectDialogView = myInflater.inflate(R.layout.connectdialog, null);
		myAlertBuilder.setView(connectDialogView)
				.setCancelable(true).setNegativeButton(
				"Cancel", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// Hide the keyboard since we handle it manually
						InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
						imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
						dialog.cancel();
					}
				})
				.setPositiveButton("Inquire", new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int id) {
						TextView view = (TextView) connectDialogView.findViewById(R.id.edit_text_connect);
						serverToCall = view.getText().toString().trim();
						if (serverToCall.length() == 0) {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
							dialog.cancel();
							topToastText("Server Call can't be blank");
						} else {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(connectDialogView.getWindowToken(), 0);
							//Send the Inquire command
							try {
//								Processor.q.send_inquire();
							}
							catch (Exception ex) {
								loggingclass.writelog(
										"Button Execution error: " + ex.getMessage(), null,
										true);
							}
						}
					}
				});

		AlertDialog myConnectAlert = myAlertBuilder.create();
		EditText view = (EditText) connectDialogView.findViewById(R.id.edit_text_connect);
		if (serverToCall.length() == 0) { //use default server call from preferences
			String defaultServerCall = config.getPreference("SERVER");
			view.setText(defaultServerCall);
		} else { //We had already typed-in a server call. Propose first as we are likely to use it again
			view.setText(serverToCall);
		}
		myConnectAlert.setTitle("Server to Inquire From");
		myConnectAlert.show();
	}

	 */

	//Handling of submit button
	public void onLoadResource(WebView view, String url)
	{
		int index = url.indexOf("FORM?");
		if (index != -1)
		{
			String d = URLDecoder.decode(url.substring(index + 5));
			bottomToastText(d);
		}
	}


	// Display one of the Messages layouts and associate it's buttons
	private void displayMessages(int screenAnimation, int msgScreen) {

		setContentView(R.layout.mail);
		screenAnimation((ViewGroup) findViewById(R.id.mailscreen), screenAnimation);

		// LayoutInflater for popup windows
		inflater = (LayoutInflater) this
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

		// Initialize the adapter for the exchange thread with server
		msgArrayAdapter = new ArrayAdapter<String>(this, R.layout.maillistview);
		msgListView = (ListView) findViewById(R.id.maillist);
		msgListView.setAdapter(msgArrayAdapter);
		msgListView.setDividerHeight(8);

		currentview = msgScreen;
		lastMsgScreen = currentview; // remember which email screen we were on

		switch (msgScreen) {
		case MSGHTMLVIEW:
			// Load inbox mails
			LoadReceived();
			// Set listener for item selection
			msgListView
			.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the message
					try {
						View layout = inflater.inflate(R.layout.htmldisplaypopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos 
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						//TextView emailText = (TextView) layout.findViewById(R.id.emailtext);
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			

						//String myDisplayForm = new String();
						mDisplayForm = "";
						try
						{
							//First read the template
							mFileName = (String) parent.getItemAtPosition(position);
							Processor.PostToTerminal("Templ. name <" + mFileName.substring(mFileName.lastIndexOf(".") + 1) + ".html" + ">\n\n");
							File f = new File(Processor.HomePath + Processor.Dirprefix
									+ "Templates" + Processor.Separator + mFileName.substring(mFileName.lastIndexOf(".") + 1) + ".html");
							FileInputStream fileIS = new FileInputStream(f);
							BufferedReader buf = new BufferedReader(new InputStreamReader(fileIS));
							String readString = new String();
							while ((readString = buf.readLine()) != null)
							{
								mDisplayForm += readString + "\n";
							}

							// Then replace the fields with the data received
							File f1 = new File(Processor.HomePath + Processor.Dirprefix
									+ "Received" + Processor.Separator + mFileName);
							FileInputStream fileIS1 = new FileInputStream(f1);
							BufferedReader buf1 = new BufferedReader(new InputStreamReader(fileIS1));
							String readString1 = new String();
							String fieldName = new String();
							String fieldValue = new String();
							while ((readString1 = buf1.readLine()) != null)
							{
								//Check for file name section
								Pattern psc = Pattern.compile("(:.+:)\\d+ (.+)");
								Matcher msc = psc.matcher(readString1);
								if (msc.lookingAt())
								{
									fieldName = msc.group(1);
									// Processor.PostToTerminal("Field name <" + fieldName + ">\n");
									fieldValue = msc.group(2);
									// Processor.PostToTerminal("Field value <" + fieldValue + ">\n\n");
									mDisplayForm = mDisplayForm.replace(fieldName, fieldValue);
								}
							}
							//Finally Remove the missing ":xxxx:" field templates that were not transmitted (because they were blank)
							Pattern psc = Pattern.compile("\\:\\S+\\:");
							Matcher msc = psc.matcher(mDisplayForm);
							while (msc.find())
							{
								fieldName = msc.group(0);
								mDisplayForm = mDisplayForm.replace(fieldName, "");
							}
						}
						catch (FileNotFoundException e)
						{
							e.printStackTrace();
						}
						catch (IOException e)
						{
							e.printStackTrace();
						}

						mWebView.loadData(mDisplayForm, "text/html", "UTF-8"); 

						// Processor.PostToTerminal("\nForm:\n" + myDisplayForm +"\n");

						// String customHtml = "<html><body><h1>Hello, WebView</h1></body></html>";
						// mWebView.loadData(customHtml, "text/html", "UTF-8");


						// Initialize the return button
						Button myButton = (Button) layout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								pw.dismiss(); // close popup
							}
						});
						// Initialize the share button
						myButton = (Button) layout
								.findViewById(R.id.button_share);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								FileWriter out = null;
								String tempFileName = new String();
								//Create temporary html file to attach to email
								tempFileName = Processor.HomePath + 
										Processor.Dirprefix + "TempHtml" + Processor.Separator + 
										mFileName.substring(0,mFileName.lastIndexOf(".")) + ".html";
								Processor.PostToTerminal("tempFileName <" + tempFileName + ">\n\n");
								File htmlFormatedFile = new File(tempFileName);
								try
								{
									if (htmlFormatedFile.exists()) {
										htmlFormatedFile.delete();
									}
									out = new FileWriter(htmlFormatedFile, true);
									out.write(mDisplayForm);
									out.close();
								}
								catch (IOException e)
								{
									loggingclass.writelog("Error creating temporary file in TempHtml folder", e, true);
								}

								Intent share = new Intent(Intent.ACTION_SEND);
								share.setType("text/plain");
								share.putExtra(Intent.EXTRA_TEXT, "Form attached\n");
								//share.putExtra(Intent.EXTRA_HTML_TEXT, myDisplayForm);
								//share.putExtra(Intent.EXTRA_TEXT, mDisplayForm);
								share.putExtra(Intent.EXTRA_STREAM, Uri.fromFile(new File(tempFileName)));
								//startActivity(Intent.createChooser(share, "Share Form"));
								//topToastText("Email copied to Clipboard");
								//Intent emailIntent = new Intent(Intent.ACTION_SENDTO, 
								//								Uri.fromParts("mailto", mailId, null)); 
								share.putExtra(Intent.EXTRA_SUBJECT, "Message " + mFileName); 
								// you can use simple text like this
								// emailIntent.putExtra(android.content.Intent.EXTRA_TEXT,"Body text here"); 
								// or get fancy with HTML like this
								// share.putExtra(Intent.EXTRA_TEXT, Html.fromHtml(myDisplayForm));
								startActivity(Intent.createChooser(share, "Send Form..."));
							}
						});
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required for web pages
			topToastText("HTML Message View Screen \n\nLong Press on a file for display");
			break;
		case MSGTEMPLATEVIEW:
			// Load outbox mails
			LoadTemplates();
			// Set listener for item selection
			msgListView
			.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the mail
					try {
						View layout = inflater.inflate(R.layout.htmldisplaypopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						//TextView emailText = (TextView) layout.findViewById(R.id.emailtext);
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			

						//String myDisplayForm = new String();
						mDisplayForm = "";
						try
						{
							String mFileName = (String) parent.getItemAtPosition(position);
							File f = new File(Processor.HomePath + Processor.Dirprefix
									+ "Templates" + Processor.Separator + mFileName);
							FileInputStream fileIS = new FileInputStream(f);
							BufferedReader buf = new BufferedReader(new InputStreamReader(fileIS));
							String readString = new String();
							while ((readString = buf.readLine()) != null)
							{
								mDisplayForm += readString + "\n";
							}
						}
						catch (FileNotFoundException e)
						{
							e.printStackTrace();
						}
						catch (IOException e)
						{
							e.printStackTrace();
						}

						mWebView.loadData(mDisplayForm, "text/html", "UTF-8"); 

						// Processor.PostToTerminal("\nForm:\n" + myDisplayForm +"\n");

						// String customHtml = "<html><body><h1>Hello, WebView</h1></body></html>";
						// mWebView.loadData(customHtml, "text/html", "UTF-8");

						// Initialize the return button
						Button myButton = (Button) layout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								pw.dismiss(); // close popup
							}
						});
						// Initialize the copy to clipboard button
						myButton = (Button) layout
								.findViewById(R.id.button_share);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
							//	if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//	android.content.ClipboardManager myCBM = (android.content.ClipboardManager)	getSystemService(CLIPBOARD_SERVICE);							
							//	android.content.ClipData clip = ClipData.newPlainText("label", emaillist.get(position)
							//			.getRawmessage());
							//	myCBM.setPrimaryClip(clip);
							//	topToastText("Email copied to Clipboard");
							//	} else {
							//		android.text.ClipboardManager myCBM = (android.text.ClipboardManager)	getSystemService(CLIPBOARD_SERVICE);							
							//		myCBM.setText(emaillist.get(position).getRawmessage());
							//		topToastText("Email copied to Clipboard");
							//	}
							}
						});
					} catch (Exception e) {
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required for web pages
			topToastText("Templates View Screen \n\nLong Press on a file for display");
			break;

		case MSGSENTITEMSVIEW:
			LoadSentMessages();
			break;


		default:
			// Either this is what we wanted or it's not implemented yet.
			// Anyway, go to the message list by default
			// Display received message list
			// Load inbox mails
			LoadReceived();
			// Set listener for item selection
			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the message
					try {
						View layout = inflater.inflate(R.layout.textdisplaypopup,
								(ViewGroup) findViewById(R.id.mail_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						TextView emailText = (TextView) layout.findViewById(R.id.emailtext);
						//mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			

						//String myDisplayForm = new String();
						mDisplayForm = "";
						try
						{
							//First read the template
							mFileName = (String) parent.getItemAtPosition(position);
							Processor.PostToTerminal("Templ. name <" + mFileName.substring(mFileName.lastIndexOf(".") + 1) + ".txt" + ">\n\n");
							File f = new File(Processor.HomePath + Processor.Dirprefix
									+ "Templates" + Processor.Separator + mFileName.substring(mFileName.lastIndexOf(".") + 1) + ".txt");
							FileInputStream fileIS = new FileInputStream(f);
							BufferedReader buf = new BufferedReader(new InputStreamReader(fileIS));
							String readString = new String();
							while ((readString = buf.readLine()) != null)
							{
								mDisplayForm += readString + "\n";
							}

							// Then replace the fields with the data received
							File f1 = new File(Processor.HomePath + Processor.Dirprefix
									+ "Received" + Processor.Separator + mFileName);
							FileInputStream fileIS1 = new FileInputStream(f1);
							BufferedReader buf1 = new BufferedReader(new InputStreamReader(fileIS1));
							String readString1 = new String();
							String fieldName = new String();
							String fieldValue = new String();
							while ((readString1 = buf1.readLine()) != null)
							{
								//Check for file name section
								Pattern psc = Pattern.compile("(:.+:)\\d+ (.+)");
								Matcher msc = psc.matcher(readString1);
								if (msc.lookingAt())
								{
									fieldName = msc.group(1);
									// Processor.PostToTerminal("Field name <" + fieldName + ">\n");
									fieldValue = msc.group(2);
									// Processor.PostToTerminal("Field value <" + fieldValue + ">\n\n");
									mDisplayForm = mDisplayForm.replace(fieldName, fieldValue);
								}
							}
							//Finally Remove the missing ":xxxx:" field templates that were not transmitted (because they were blank)
							Pattern psc = Pattern.compile("\\:\\S+\\:");
							Matcher msc = psc.matcher(mDisplayForm);
							while (msc.find())
							{
								fieldName = msc.group(0);
								mDisplayForm = mDisplayForm.replace(fieldName, "");
							}
						}
						catch (FileNotFoundException e)
						{
							e.printStackTrace();
						}
						catch (IOException e)
						{
							e.printStackTrace();
						}

						//mWebView.loadData(myDisplayForm, "text/html", "UTF-8"); 
						emailText.setText(mDisplayForm);


						// Initialize the return button
						Button myButton = (Button) layout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								pw.dismiss(); // close popup
							}
						});
						// Initialize the share button
						myButton = (Button) layout
								.findViewById(R.id.button_share);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
								Intent share = new Intent(Intent.ACTION_SEND);
								share.setType("text/plain");
								//share.putExtra(Intent.EXTRA_TEXT, "Form below:");
								//share.putExtra(Intent.EXTRA_HTML_TEXT, myDisplayForm);
								//share.putExtra(Intent.EXTRA_TEXT, myDisplayForm);
								//startActivity(Intent.createChooser(share, "Share Form"));
								//topToastText("Email copied to Clipboard");
								//} else {
								//	android.text.ClipboardManager myCBM = (android.text.ClipboardManager)	getSystemService(CLIPBOARD_SERVICE);							
								//	myCBM.setText(emaillist.get(position).getRawmessage());
								//	topToastText("Not coded yet");
								//}
								//Intent emailIntent = new Intent(Intent.ACTION_SENDTO, 
								//								Uri.fromParts("mailto", mailId, null)); 

								// share.putExtra(android.content.Intent.EXTRA_SUBJECT, "Subject text here"); 
								// you can use simple text like this
								// emailIntent.putExtra(android.content.Intent.EXTRA_TEXT,"Body text here"); 
								// or get fancy with HTML like this
								share.putExtra(Intent.EXTRA_SUBJECT, "Message " + mFileName);
								share.putExtra(Intent.EXTRA_TEXT, mDisplayForm);
								startActivity(Intent.createChooser(share, "Send Form..."));
							}
						});
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required for web pages
			topToastText("Messages Text View Screen\n\nLong Press on a file to display");
			break;

		}

		// Initialize the common buttons

		// Initialize the Text Message view button
		myButton = (Button) findViewById(R.id.button_headers);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Open the mail headers layout
				displayMessages(BOTTOM, MSGTEXTVIEW);
			}
		});

		// Initialize the HTML Message view button
		myButton = (Button) findViewById(R.id.button_inbox);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Open the mail headers layout
				displayMessages(BOTTOM, MSGHTMLVIEW);
			}
		});

		// Initialize the Template view button
		myButton = (Button) findViewById(R.id.button_outbox);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Open the mail headers layout
				displayMessages(BOTTOM, MSGTEMPLATEVIEW);
			}
		});


		/*

		//Code left here for future reference when setting the GUI buttons

		// Initialize the Mail Sent Items button
		myButton = (Button) findViewById(R.id.button_sentitems);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Open the mail headers layout
				displayMessages(BOTTOM, MSGSENTITEMSVIEW);
			}
		});

		// JD Initialize the QTC button
		myButton = (Button) findViewById(R.id.button_qtc);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				TextView view = (TextView) findViewById(R.id.edit_text_out);
				String message = view.getText().toString();

				if (Processor.ReceivingForm) {
					if (message.length() > 0) {
						try {
							topToastText("Requesting Headers from "
									+ message.trim());
							Processor.TX_Text += ("~QTC " + message.trim() + "+\n");
						}
						// JD fix this catch action
						catch (Exception ex) {
							// System.out.println(ex.getMessage());
							loggingclass.writelog("Button Execution error: "
									+ ex.getMessage(), null, true);
						}
					} else {
						String mailnr = "";
						mailnr = Processor.sm.getHeaderCount(Processor.HomePath
								+ Processor.Dirprefix + "headers");
						Processor.sm.sendQTC(mailnr);
						topToastText("Requesting Headers from " + mailnr);
					}
				} else {
					bottomToastText("You Must Connect First");
				}
			}

		});



		// Initialize the New Mail button
		myButton = (Button) findViewById(R.id.button_newmail);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Open the new mail layout
				displayNewmail();
			}
		});

		// JD Initialize the SEND Mail button
		myButton = (Button) findViewById(R.id.button_sendmail);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					SendButtonAction();
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the DELETE Mail button
		myButton = (Button) findViewById(R.id.button_delete);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				TextView view = (TextView) findViewById(R.id.edit_text_out);
				String message = view.getText().toString();

				if (Processor.ReceivingForm) {
					if (message.length() > 0) {
						try {
							Processor.TX_Text += ("~DELETE " + message + "\n");
							topToastText("Requesting Deletion of your email...");
						}
						// JD fix this catch action
						catch (Exception ex) {
							topToastText("Type below the email number to delete");
						}
					} else {
						Processor.TX_Text += ("QTC 0+\n");
					}
				} else {
					bottomToastText("You Must Connect First");
				}
			}
		});

		 */

	} 


	//Keep here for new Message creation when ready for TXing
	// Display the New Message layout and associate it's buttons
	private void displayNewMessage() {
		currentview = NEWMSGVIEW;

		// Ensure the keyboard is shown
		setContentView(R.layout.newmessage);
		// Bring up the keyboard since we asked the system not to do it by default
		InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		TextView NewToField = (TextView) findViewById(R.id.emailaddress);
		TextView NewSubjectField = (TextView) findViewById(R.id.emailsubject);

		imm.toggleSoftInput(InputMethodManager.SHOW_FORCED, 0);
		// NewSubjectField.setFocusable(true);
		NewSubjectField.requestFocus();
		// NewToField.setFocusable(true);
		NewToField.requestFocus();

		// JD Initialize the BROWSE Contacts button
		myButton = (Button) findViewById(R.id.button_Browse_Contacts);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					Intent contactPickerIntent = new Intent(Intent.ACTION_PICK,
							Contacts.CONTENT_URI);
					startActivityForResult(contactPickerIntent, CONTACT_PICKER_RESULT);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Browse Contacts button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the POST to Outbox button
		myButton = (Button) findViewById(R.id.button_tooutbox);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				TextView NewToField = (TextView) findViewById(R.id.emailaddress);
				TextView NewSubjectField = (TextView) findViewById(R.id.emailsubject);
				TextView NewTxtArea = (TextView) findViewById(R.id.emailbody);
				FileWriter out = null;
				// Hide the keyboard since we handle it manually
				InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
				imm.hideSoftInputFromWindow(NewTxtArea.getWindowToken(), 0);

				try {
					String NewMailText = "\n~SEND\n";
					NewMailText += "From: "
							+ config.getPreference("RETURNADDRESS") + "\n";
					NewMailText += "To: " + NewToField.getText() + "\n";
					NewMailText += "Subject: " + NewSubjectField.getText()
							+ "\n";
					NewMailText += NewTxtArea.getText();
					/*
					 * JD attachments: Not yet String s = ""; String att = "";
					 * if (myattachment.length() > 0) { att =
					 * Base64.encodeFromFile(myattachment); File ff = new
					 * File(myattachment); String name = ff.getName();
					 * 
					 * if (att.length() > 0) { NewMailText +=
					 * "\nYour attachment: filename=" + Character.toString('"')
					 * + name + Character.toString('"') + "\n"; NewMailText +=
					 * att + "\n"; } myattachment = ""; }
					 * Processor.log.writelog("Button Execution error: " +
					 * ex.getMessage(), null, true);
					 */
					NewMailText += ".\n.\n";

					File sent = new File(Processor.HomePath + Processor.Dirprefix + "Sentmail");
					out = new FileWriter(sent, true);
					out.write("\nSent at: " + Processor.myTime());
					out.write(NewMailText);
					out.close();

					Random r = new Random();
					String token = Long.toString(Math.abs(r.nextLong()), 12);
					token = "tmp" + token;
					File outFile = new File(Processor.HomePath
							+ Processor.Dirprefix + "Outbox"
							+ Processor.Separator + token);
					out = new FileWriter(outFile);
					out.write(NewMailText);
					out.close();

					// this.setVisible(false);
					displayMessages(NORMAL, lastMsgScreen);
					topToastText("Email Sent to Outbox");

				} catch (IOException ex) {
					// JD Fix this
					// Logger.getLogger(this.getName()).log(Level.SEVERE, null,
					// ex);
				}
			}

		});

		// JD Initialize the DISCARD Mail button
		myButton = (Button) findViewById(R.id.button_discard);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Hide the keyboard since we handle it manually
				InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
				TextView NewTxtArea = (TextView) findViewById(R.id.emailbody);
				imm.hideSoftInputFromWindow(NewTxtArea.getWindowToken(), 0);
				// Just return to mail headers
				try {
					displayMessages(NORMAL, lastMsgScreen);
					topToastText("Email Discarded");
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});
	}




	// Display the Modem layout and associate it's buttons
	private void displayModem(int screenAnimation, boolean withWaterfall) {

		if (withWaterfall) {
			currentview = MODEMVIEWwithWF;
			setContentView(R.layout.modemwithwf);
			screenAnimation((ViewGroup) findViewById(R.id.modemwwfscreen), screenAnimation);
			// Get the waterfall view object for the runnable
			myWFView = (waterfallView) findViewById(R.id.WFbox);
		} else {
			currentview = MODEMVIEWnoWF;
			setContentView(R.layout.modemwithoutwf);
			screenAnimation((ViewGroup) findViewById(R.id.modemnwfscreen), screenAnimation);
			myWFView = null;
		}

		myModemTV = (TextView) findViewById(R.id.modemview);
		myModemTV.setHorizontallyScrolling(false);
		myModemTV.setTextSize(16);
		if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11) {
			myModemTV.setTextIsSelectable(false);
		}

		// initialise CPU load bar display
		CpuLoad = (ProgressBar) findViewById(R.id.cpu_load);

		// initialise squelch and signal quality dislay
		SignalQuality = (ProgressBar) findViewById(R.id.signal_quality);

		// Reset modem display in case it was blanked out by a new oncreate call
		myModemTV.setText(ModemBuffer);
		myModemSC = (ScrollView) findViewById(R.id.modemscrollview);
		// update with whatever we have already accumulated then scroll
		AndFlmsg.mHandler.post(AndFlmsg.addtomodem);

		// Advise user of which screen we are in
		topToastText("Modem Screen");

		if (withWaterfall) { // initialise two extra buttons

			// JD Initialize the Waterfall Sensitivity UP button
			myButton = (Button) findViewById(R.id.button_wfsensup);
			myButton.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					try {
						if (myWFView != null) {
							myWFView.maxvalue /= 1.25;
							if (myWFView.maxvalue < 1)
								myWFView.maxvalue = 1.0;
							// store value into preferences
							SharedPreferences.Editor editor = AndFlmsg.mysp
									.edit();
							editor.putFloat("WFMAXVALUE",
									(float) myWFView.maxvalue);
							// Commit the edits!
							editor.commit();
						}
					}
					// JD fix this catch action
					catch (Exception ex) {
						loggingclass.writelog(
								"Button Execution error: " + ex.getMessage(),
								null, true);
					}
				}
			});

			// JD Initialize the Waterfall Sensitivity DOWN button
			myButton = (Button) findViewById(R.id.button_wfsensdown);
			myButton.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					try {
						if (myWFView != null) {
							myWFView.maxvalue *= 1.25;
							if (myWFView.maxvalue > 40)
								myWFView.maxvalue = 40.0;
							// store value into preferences
							SharedPreferences.Editor editor = AndFlmsg.mysp.edit();
							editor.putFloat("WFMAXVALUE", (float) myWFView.maxvalue);
							// Commit the edits!
							editor.commit();
						}
					}
					// JD fix this catch action
					catch (Exception ex) {
						loggingclass.writelog(
								"Button Execution error: " + ex.getMessage(),
								null, true);
					}
				}
			});

		}

		// JD Initialize the MODEM RX ON/OFF button
		myButton = (Button) findViewById(R.id.button_modemONOFF);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (ProcessorON) {
						if (Modem.modemState == Modem.RXMODEMRUNNING && 
								!Processor.ReceivingForm && !Processor.TXActive) {
							modemPaused = true;
							Modem.stopRxModem();	
							stopService(new Intent(AndFlmsg.this, Processor.class));
							//Force garbage collection to prevent Out Of Memory errors on small RAM devices
							System.gc();
						}
						//Only for Android 3.0 and UP
						if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//Remove the notification
							myNotificationManager.cancel(9999);
						}
						ProcessorON = false;
						//Set modem text as selectable
						TextView myTempModemTV = (TextView) findViewById(R.id.modemview);
						if (myTempModemTV != null) {
							if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11) {
								myTempModemTV.setTextIsSelectable(true);
							}
						}
					} else {
						if (Modem.modemState == Modem.RXMODEMIDLE) {
							modemPaused = false;
							//Force garbage collection to prevent Out Of Memory errors on small RAM devices
							System.gc();
							startService(new Intent(AndFlmsg.this,
									Processor.class));
							//Only for Android 3.0 and UP
						}
						ProcessorON = true;
						//Set modem text as NOT selectable
						TextView myTempModemTV = (TextView) findViewById(R.id.modemview);
						if (myTempModemTV != null) {
							if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11) {
								myTempModemTV.setTextIsSelectable(false);
							}
						}
						if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//Issue the notification
							myNotificationManager.notify(9999, myNotification);
						}
					}
					AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the MODE UP button
		myButton = (Button) findViewById(R.id.button_modeUP);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (!Processor.ReceivingForm && ProcessorON
							&& !Processor.TXActive && Modem.modemState == Modem.RXMODEMRUNNING) {
						Processor.TxModem = Processor.RxModem = Modem.getModeUpDown(Processor.RxModem, +1);
						Modem.changemode(Processor.RxModem); // to make the changes effective
						AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the MODE DOWN button
		myButton = (Button) findViewById(R.id.button_modeDOWN);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (!Processor.ReceivingForm && ProcessorON
							&& !Processor.TXActive && Modem.modemState == Modem.RXMODEMRUNNING) {
						Processor.TxModem = Processor.RxModem = Modem.getModeUpDown(Processor.RxModem, -1);
						Modem.changemode(Processor.RxModem); // to make the changes effective
						AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
					}
				}
			// JD fix this catch action
			catch (Exception ex) {
				loggingclass.writelog(
						"Button Execution error: " + ex.getMessage(), null,
						true);
			}
		}
	});

		// JD Initialize the Squelch UP button
		myButton = (Button) findViewById(R.id.button_squelchUP);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					Modem.AddtoSquelch(5.0);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the Squelch DOWN button
		myButton = (Button) findViewById(R.id.button_squelchDOWN);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					Modem.AddtoSquelch(-5.0);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the TUNE button
		myButton = (Button) findViewById(R.id.button_tune);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {

					if (!Processor.TXActive && !Processor.ReceivingForm &&
							Modem.modemState == Modem.RXMODEMRUNNING) {
						Modem.TxTune();
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the WATERFALL ON/OFF button
		myButton = (Button) findViewById(R.id.button_waterfallONOFF);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (currentview == MODEMVIEWnoWF) {
						displayModem(NORMAL,true);
					} else {
						displayModem(NORMAL, false);
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the STOP TX button
		myButton = (Button) findViewById(R.id.button_stopTX);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (Processor.TXActive) {
						Modem.stopTX = true;
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

}



	// Display the About screen
	private void displayAbout() {
		currentview = ABOUTVIEW;

		// Open APRS layout by default until we have other activities defined
		setContentView(R.layout.about);
		TextView myversion = (TextView) findViewById(R.id.versiontextview);
		myversion.setText("          " + Processor.version);

		// JD Initialize the return to terminal button
		myButton = (Button) findViewById(R.id.button_returntoterminal);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayTerminal(BOTTOM);
			}
		});

	}

	/*	
		//Keep for future reference when ready for TXing

		// When pressing the send button on the email or terminal screen
		private void SendButtonAction() {
			if (Processor.ReceivingForm) {
				// FileReader out = null;
				if (Processor.compressedMsg) {
					try {

						File dir = new File(Processor.HomePath
								+ Processor.Dirprefix + "Outbox");

						File[] files = dir.listFiles();

						long files0length = 0;
						if (files.length > 0) {
							files0length = files[0].length();
						}

						File dir2 = new File(Processor.HomePath
								+ Processor.Dirprefix + "Outpending");

						File[] files2 = dir2.listFiles();

						if (files2.length > 0) {
							topToastText("Trying_to_send_your_email...");
							if (files2[0].length() > 0) {

								String FileOut = files2[0].toString();
								int i = FileOut.lastIndexOf(File.separator);
								String ffilename = (i > -1) ? FileOut
										.substring(i + 1) : FileOut;

										File fpendir = new File(Processor.Outpendingdir);
										File[] fpendingfiles = fpendir.listFiles();

										String fname = "mail";
										File testTransactions = new File(
												Processor.Transactions);
										if (testTransactions.exists()) {

											FileReader trf = new FileReader(
													Processor.Transactions);
											BufferedReader bf = new BufferedReader(trf);
											String s = "";

											while ((s = bf.readLine()) != null) {
												if (s.contains(ffilename)) {
													String[] ss = s.split(":");
													fname = ss[5];
												}
											}
										}

										if (fpendingfiles.length > 0) {
											String penfile0 = fpendingfiles[0].toString();

											if (penfile0.length() > 0) {
												String outfile = penfile0;
												i = outfile.lastIndexOf(File.separator);
												ffilename = (i > -1) ? outfile
														.substring(i + 1) : outfile;
														Processor.TX_Text += "~FO5:"
																+ Processor.sm.mycall
																+ ":"
																+ Processor.sm.myserver
																+ ":"
																+ ffilename
																+ ":u:"
																+ fname
																+ ":"
																+ Long.toString(fpendingfiles[0]
																		.length()) + "\n";
											}
										}
							}
							// Prevent Exception on NO FILE: } else if (files.length
							// > 0 & files[0].length() > 0) {
						} else if (files.length > 0 && files0length > 0) {
							topToastText("Trying to send your email...");
							Processor.Mailoutfile = files[0].toString();
							int j = Processor.Mailoutfile
									.lastIndexOf(File.separator);
							String filename = (j > -1) ? Processor.Mailoutfile
									.substring(j + 1) : Processor.Mailoutfile;

									File pendir = new File(Processor.Pendingdir);
									File[] pendingfiles = pendir.listFiles();

									if (pendingfiles.length > 0) {
										String penfile0 = pendingfiles[0].toString();

										if (penfile0.length() > 0) {
											String outfile = penfile0;
											j = outfile.lastIndexOf(File.separator);
											filename = (j > -1) ? outfile.substring(j + 1)
													: outfile;
											Processor.TX_Text += "~FO5:"
													+ Processor.mycall
													+ ":"
													+ Processor.sm.myserver
													+ ":"
													+ filename
													+ ":s: :"
													+ Long.toString(pendingfiles[0]
															.length()) + "\n";
										}
									} else {
										// no pending message
										String zippedfile = Processor.HomePath
												+ Processor.Dirprefix + "tmp.mail";
										String codedfile = Processor.HomePath
												+ Processor.Dirprefix + "tmp2.mail";

										FileInputStream in = new FileInputStream(
												Processor.Mailoutfile);
										GZIPOutputStream gzout = new GZIPOutputStream(
												new FileOutputStream(zippedfile));
										byte[] buffer = new byte[4096];
										int bytesRead;
										while ((bytesRead = in.read(buffer)) != -1) {
											gzout.write(buffer, 0, bytesRead);
										}
										in.close();
										gzout.close();
										Base64.encodeFileToFile(zippedfile, codedfile);

										File filelength = new File(codedfile);

										int length = (int) filelength.length();
										Session.DataSize = length;
										Session.DataReceived = 0;
										String lengthstr = Integer.toString(length);

										FileReader b64in = new FileReader(codedfile);
										//
										BufferedReader br = new BufferedReader(b64in);

										FileWriter fstream = new FileWriter(
												Processor.Pendingdir + filename);
										BufferedWriter pout = new BufferedWriter(fstream);

										if (Processor.protocol == 0) {
											Processor.TX_Text += "~CSEND\n";
										} else {
											String callsign = config.getPreference("CALL");
											callsign = callsign.trim();
											String servercall = AndFlmsg.serverToCall;
											servercall = servercall.trim();
											Processor.TX_Text += ">FM:" + callsign + ":"
													+ servercall + ":" + filename + ":s: :"
													+ lengthstr + "\n";
										}
										String record = null;
										while ((record = br.readLine()) != null) {
											Processor.TX_Text += record + "\n";
											if (Processor.protocol > 0) {
												pout.write(record + "\n");
											}
										}
										Processor.TX_Text += "-end-\n";
										if (Processor.protocol > 0) {
											pout.write("-end-\n");
											pout.close();
										}

										Session.DataSize = Processor.TX_Text.length();

										boolean success = true;
										File f = new File(zippedfile);
										if (f.exists()) {
											success = f.delete();
										}
										if (!success) {
											loggingclass.writelog(
													"Error deleting temporary zip file",
													null, true);
										}

									}
						} else {
							topToastText("No Mail to Send...");
						}
					} catch (IOException ex) {
						loggingclass
						.writelog("Error processing compressed Mail Send",
								null, true);
					}
				} else {
					// not compressed (default)
					try {
						File dir = new File(Processor.HomePath
								+ Processor.Dirprefix + "Outbox");
						File[] files = dir.listFiles();

						if (files.length > 0) {
							topToastText("Trying to send your email...");
							Processor.Mailoutfile = files[0].getAbsolutePath();
							FileReader in = new FileReader(files[0]);
							BufferedReader br = new BufferedReader(in);
							String record = null;
							while ((record = br.readLine()) != null) {
								Processor.TX_Text += record + "\n";
							}

						} else {
							topToastText("No Mail to Send...");
						}
					} catch (IOException ex) {
						loggingclass.writelog(
								"Error processing UNcompressed Mail Send", null,
								true);
					}
				}
			} else {
				bottomToastText("You Must Connect First");
			}
		}
	 */


	/*	
		//Keep for future references

		private void LoadWebpages() {
			try {
				WebArrayAdapter.clear();
				for (int i = 6; i > 0; i--) {
					String url = config.getPreference(
							"URL" + Integer.toString(i), "");
					String beginstring = config.getPreference("URL"
							+ Integer.toString(i) + "B", "");
					if (beginstring.trim().length() > 0) {
						beginstring = "   Begin: " + beginstring;
					}
					String endstring = config.getPreference("URL"
							+ Integer.toString(i) + "E", "");
					if (endstring.trim().length() > 0) {
						endstring = "   End: " + endstring;
					}
					if (url.trim().length() > 0) {
						// WebArrayAdapter.add(Integer.toString(i) + ".  " + url +
						// beginstring + endstring);
						WebArrayAdapter.insert(Integer.toString(i) + ".  " + url
								+ beginstring + endstring, 0);
					} else {
						// WebArrayAdapter.add(Integer.toString(i) + ".  ");
						WebArrayAdapter.insert(Integer.toString(i) + ".  ", 0);
					}
				}

			} catch (Exception e) {
				loggingclass.writelog("Error when showing mail headers.", e, true);
			}
		}
	 */

	/*	
		private void LoadHeaders() {
			try {
				// Open the file
				FileReader frs = new FileReader(Processor.HomePath
						+ Processor.Dirprefix + "headers");
				BufferedReader br = new BufferedReader(frs);
				String s;
				msgArrayAdapter.clear();
				while ((s = br.readLine()) != null) {
					if (s.length() > 10) {
						String[] mystrarr = new String[4];
						Integer myA = s.indexOf(" ");
						if (myA < 2)
							myA = 2;
						mystrarr[0] = s.substring(0, myA).trim(); // Number
						// From
						Integer myB = s.indexOf("  ");
						mystrarr[1] = s.substring(myA + 1, myB).trim();
						// Subject
						Integer myC = s.lastIndexOf(" ");
						mystrarr[2] = s.substring(myB + 2, myC).trim();
						// Size
						mystrarr[3] = s.substring(myC, s.length()).trim();
						msgArrayAdapter.add(mystrarr[0] + "  " + mystrarr[1]
								+ "  " + mystrarr[2] + "  " + mystrarr[3]);
					}
				}
				frs.close();
			} catch (Exception e) {
				loggingclass.writelog("Error when showing mail headers.", e, true);
			}
		}
	 */

	// Loads the list of Received flmsg messages (raw data)
	private void LoadReceived()
	{
		try
		{
			// Get the list of files in the Received folder
			File dir = new File(Processor.HomePath + Processor.Dirprefix
					+ "Received");
			File[] files = dir.listFiles(); // This filter only returns files
			FileFilter fileFilter = new FileFilter() {
				public boolean accept(File file)
				{
					return file.isFile();
				}
			};

			// We should now have an array of strings containing the file names
			files = dir.listFiles(fileFilter);
			msgArrayAdapter.clear();
			for (int i = 0; i < files.length; i++)
			{
				msgArrayAdapter.add(files[i].getName());
			}
		}
		catch (Exception e)
		{
			loggingclass.writelog("Error when showing Outbox.", e, true);
		}
	}

	// Loads the list of files from the Template directory (several file)
	private void LoadTemplates()
	{

		try
		{
			// Get the list of files in the outbox
			File dir = new File(Processor.HomePath + Processor.Dirprefix
					+ "Templates");
			File[] files = dir.listFiles(); // This filter only returns files
			FileFilter fileFilter = new FileFilter() {
				public boolean accept(File file)
				{
					return file.isFile();
				}
			};

			// We should now have an array of strings containing the file names
			files = dir.listFiles(fileFilter);
			msgArrayAdapter.clear();
			for (int i = 0; i < files.length; i++)
			{
				msgArrayAdapter.add(files[i].getName());
			}
		}
		catch (Exception e)
		{
			loggingclass.writelog("Error when showing Outbox.", e, true);
		}
	}


	private void LoadSentMessages() {
		try {
			//Check is file is present. If not, create a blank one
			File sentItemsFile = new File(Processor.HomePath
					+ Processor.Dirprefix + "sentmail");
			if (!sentItemsFile.exists()) {
				// File did not exist, create it
				sentItemsFile.createNewFile();
			}

			// Open the file
			FileReader frs = new FileReader(Processor.HomePath
					+ Processor.Dirprefix + "sentmail");
			BufferedReader br = new BufferedReader(frs);
			String s;
			msgArrayAdapter.clear();
			String thisMail = "";
			boolean storing = false;
			while ((s = br.readLine()) != null) {
				if (!storing) {
					//Located the start of the first email?
					if (s.startsWith("Sent at:")) {
						storing = true;
						thisMail = s;
					} 
				} else {
					//Found a new sent email?
					if (s.startsWith("Sent at:")) {
						//Save it and init the next email string
						msgArrayAdapter.add(thisMail);
						thisMail = s;
					} else {
						//Just add that line
						thisMail = thisMail + "\n" + s;
					}
				}

			}
			//Have we got a last one to add when we reached EOF?
			if (thisMail.length() > 0) {
				msgArrayAdapter.add(thisMail);
			}
			// Advise user which screen we are in
			topToastText("Mail SENT Items Screen");
			frs.close();
		} catch (Exception e) {
			loggingclass.writelog("Error when showing Sent Mail.", e, true);
		}
	}


	/*

		// Process the abort Button
		private void AbortButtonAction() {
			// In case the client is TXing, ignore and ask operator to press while
			// RXing
			if (!Processor.TXActive) {

				Processor.Bulletinmode = false;
				Processor.Connecting = false;
				Processor.Scanning = false;
				Processor.sm.FileDownload = false;

				if (Processor.ReceivingForm) {
					try {

						Processor.q.send_abort();
					} catch (InterruptedException ex) {
					//To-Do: Catch section
					}
					try {
						if (Processor.sm.pFile != null) {
							Processor.sm.pFile.close();
						}
					} catch (IOException e) {
						Processor.q.Message("Cannot close pending file", 10);
					}
					try {
						if (Processor.sm.dlFile != null) {
							Processor.sm.dlFile.close();
						}
					} catch (IOException e) {
						Processor.q.Message("Cannot close pending file", 10);
					}

				} else if (Processor.TTYConnected.equals("Connected")) {
					try {
						Processor.q.send_abort();
					} catch (InterruptedException ex) {
					//To-Do: Catch section
					}
				} else {
					try {
						Processor.ReceivingForm = true;
						// disableMboxMenu();
						Processor.q.send_abort();
					} catch (InterruptedException ex) {
					//To-Do: Catch section
					}

				}


				Processor.ReceivingForm = false;
				Processor.TTYConnected = "";
				Processor.sm.FileDownload = false;
				Processor.Status = "Listening";

			} else {
				topToastText("Not Active during TX. Wait for RX and Press Again...");

			}

		}

		// Delete pending downloads (Pending directory)
		private void ClearDownloads() {
			File dir = new File(Processor.Pendingdir);
			if (dir.exists()) {
				String[] info = dir.list();
				for (int i = 0; i < info.length; i++) {
					@SuppressWarnings("static-access")
					File n = new File(Processor.Pendingdir + dir.separator
							+ info[i]);
					if (!n.isFile()) {
						continue;
					} else {
						n.delete();
					}

				}
			}
		}

		// Delete pending uploads (Outpending directory)
		private void ClearUploads() {
			FileReader tin = null;
			File uplds = new File(Processor.Transactions);
			if (uplds.exists()) {
				uplds.delete();
			}
			String fileName = Processor.Outpendingdir;
			// A File object to represent the filename
			File dir = new File(fileName);

			// Make sure the file or directory exists and isn't write protected
			if (dir.exists()) {
				String[] info = dir.list();
				for (int i = 0; i < info.length; i++) {
					@SuppressWarnings("static-access")
					File n = new File(Processor.Outpendingdir + dir.separator
							+ info[i]);
					if (!n.isFile()) {
						continue;
					} else {
						n.delete();
					}

				}
			}
		}

	 */


	// Delete Outbox directory
	private void ClearOutbox() {
		File dir = new File(Processor.HomePath + Processor.Dirprefix + "Outbox");
		if (dir.exists()) {
			String[] info = dir.list();
			for (int i = 0; i < info.length; i++) {
				File n = new File(Processor.HomePath + Processor.Dirprefix
						+ "Outbox" + File.separator + info[i]);
				if (!n.isFile()) // skip ., .., other directories too
					continue;

				if (!n.delete()) {
					topToastText("Couldn't remove " + n.getPath());
				}
			}
		}

	}


	//Keep for reference for counting/listing un-sent new messages
	// List all pending transcations in terminal
	public static void ListPendingTransactions() {
		File tr = new File(Processor.Transactions);
		FileReader fr1 = null;

		if (tr.exists()) {
			Processor.PostToTerminal("\nPending uploads:\n");
			try {
				fr1 = new FileReader(tr);
			} catch (FileNotFoundException ex) {
				//To-Do: Catch section
			}

			BufferedReader br = new BufferedReader(fr1);
			String brl = "";
			try {
				while ((brl = br.readLine()) != null) {
					String[] ss = brl.split(":");
					if (ss[4].equals("u")) {
						Processor.PostToTerminal(ss[2] + ":" + ss[5] + ":"
								+ ss[6] + "\n");
					}
				}
			} catch (IOException ex) {
				//To-Do: Catch section
			}
			try {
				br.close();
			} catch (IOException ex) {
				//To-Do: Catch section
			}
		}

		File outb1 = new File(Processor.HomePath + Processor.Dirprefix
				+ "Outbox");
		int i1 = outb1.list().length;
		Processor.PostToTerminal("\nOutbox:" + Integer.toString(i1) + "\n");

		File outb = new File(Processor.Pendingdir);
		int i = outb.list().length;

		Processor.PostToTerminal("Incomplete Downloads:" + Integer.toString(i)
				+ "\n\n");
	}

} //end of Modem class
